#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: yungyu
"""
class Test:
    """
    >>> t = Test()
    >>> t.printB()
    b = 0
    >>> t.printC()
    c = 0
    >>> t.setA(2)
    setA: 2
    >>> t.printC()
    c = 4
    >>> t.printB()
    b = 3
    >>> t.setA(3)
    setA: 3
    >>> t.printB()
    b = 4
    >>> t.printC()
    c = 5
    """
    _puppy_field_a = 0
    _puppy_field_b = 0    #pupush b = a + 1
    c = 0    #pupush c = b + 1
            
    def setA(self, na):
        print("setA:", na)
        self.a = na

    def printB(self):
        print("b =", self.b)
        
    def printC(self):
        print("c =", self.c)

    @property
    def a(self):
        return self._puppy_field_a

    @a.setter        
    def a(self, a):
        self._puppy_field_a = a
        self._puppy_update_b()
    
    def _puppy_update_b(self):
        self.b = self._puppy_field_a + 1

    @property
    def b(self):
        return self._puppy_field_b

    @b.setter        
    def b(self, b):
        self._puppy_field_b = b
        self._puppy_update_c()
    
    def _puppy_update_c(self):
        self.c = self._puppy_field_b + 1

if __name__ == "__main__":
    import doctest
    doctest.testmod()
