#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
@author: yungyu
"""
import math

class Point:
    """
    >>> p = Point(3, 4)
    >>> p.log()
    5.0
    >>> p.move(2, 8)
    >>> p.log()
    13.0
    """
    _puppy_field_x = 0
    _puppy_field_y = 0

    def __init__(self, x, y):
        self.x = x
        self.y = y
        
    def move(self, dx, dy):
        self.x += dx
        self.y += dy
        
    def log(self):
        print(self.dis)

    @property
    def x(self):
        return self._puppy_field_x

    @x.setter
    def x(self, x):
        self._puppy_field_x = x
        self._puppy_update_dis()

    @property
    def y(self):
        return self._puppy_field_y

    @y.setter
    def y(self, y):
        self._puppy_field_y = y
        self._puppy_update_dis()

    def _puppy_update_dis(self):
        self.dis =  math.sqrt(self._puppy_field_x ** 2 + self._puppy_field_y ** 2)
    
    dis = 0 #push dis = math.sqrt(x ** 2 + y ** 2)

if __name__ == "__main__":
    import doctest
    doctest.testmod()
